package database;

import database.Question.Type;

public class Answer implements Comparable<Answer>{
  
  private String text;
  private boolean wahr;
  private Question.Type type;
  private boolean usersel = false;
  private String usertxt = "";
  private boolean answered =false;
  private int position=-1;
  
  //#############################################################
  public Answer(int p, String a, Boolean w)
  {
    position=p;
    text=a;
    wahr=w;
    type=Question.Type.regexp;
  }
  
  public Answer(int p, String a, Question.Type r)
  {
    position=p;
    text=a;
    wahr=false;
    type=r;
  }
  
  public Answer(int p, String a, Boolean w, Question.Type r)
  {
    position=p;
    text=a;
    wahr=w;
    type=r;
  }
  //#############################################################
  
  //#############################################################
  public String getText(){ return text; }
  public Type getType(){ return type;}
  public boolean getUserSelection(){ return usersel;}
  public void setUserSelection(boolean b){ usersel=b; answered=true;}
  public void setUserText(String t){usertxt=t; answered=true;}
  public String getUserText(){return usertxt;}
  public boolean isAnswered(){ return answered; }
  public void resetUser(){usersel=false; usertxt=""; answered=false;}
  //#############################################################

  public boolean isUserOK()
  {
    if(type != Type.regexp)
    { return usersel==wahr; }
    else
    { return usertxt.matches(text); }
  }

  public Boolean isOK()
  { return this.wahr; }

  public int compareTo(Answer a) {
    return position-a.position;
  }
}
