package gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class Alert extends JDialog{
  private static final long serialVersionUID = -245087465178582036L;
  
  public Alert(Frame owner, String title, String text){this(owner,title,text,null);}
  public Alert(Frame owner, String title, String text, ImageIcon icon)
  {
    super(owner,title,true);
    setLayout(new BorderLayout());
    setSize(300,150);
    //setResizable(false);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

    if(icon != null)
    {
      JLabel licon = new JLabel(text,icon,0);
      licon.setVerticalAlignment(0);
      add(licon,BorderLayout.WEST);
    }

    {
      JPanel panel = new JPanel();
      panel.setLayout(new FlowLayout(FlowLayout.CENTER));
      JButton close = new JButton("OK",LoadIcon.load("apply"));
      close.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e){ close(); }});
      panel.add(close);
      add(panel, BorderLayout.SOUTH);
    }
        
    setVisible(true);
  }

  private void close()
  {
    setVisible(false);
    dispose();
  }
}
