package gui;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.*;

import database.DataBase;

public class DBConfWindow extends JDialog{
  private static final long serialVersionUID = 8743621564739338168L;
  private Leiste leiste = new DBConfLeiste();
  private DBConfPanel panel;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();

  public DBConfWindow(Frame owner, DataBase db)
  {
    super(owner,"DatenbankEinrichten",true);
    setSize(500,450);
    setResizable(false);
    setIconImage(LoadIcon.loadImage("tester"));
    addWindowListener(new WindowAdapter(){ public void windowClosing(WindowEvent e){ setVisible(false); dispose();}});
    setLayout(new BorderLayout());
    
    ActionListener acl=new ActionListener(){public void actionPerformed(ActionEvent e){ actionCommand(e.getActionCommand(),e.getSource());}};
    add(leiste,BorderLayout.SOUTH);
    leiste.addActionListener(acl);
    
    if(db!=null)
    {
      panel=new DBConfPanel(db);
      add(panel,BorderLayout.CENTER);
    }
    else
    {
      leiste.setButtonEnabled("CWACEPT", false);
      leiste.setButtonEnabled("CWOK", false);
    }
    
    setVisible(true);
  }
  
  
  private void actionCommand(String cmd, Object source)
  {
    if(cmd.equals("CWCLOSE")){setVisible(false);dispose();}
    else if(cmd.equals("CWACEPT")){panel.updateDB();}
    else if(cmd.equals("CWOK")){panel.updateDB();setVisible(false);dispose();}
    else
    doAction(cmd,source);
  }

  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void doAction(String name,Object o)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(o, 0, name)); }
}