package gui;

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;

import database.Question;

public class HelpWindow extends JFrame{
  private static final long serialVersionUID = -2474120333070019286L;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();
  
  private JLabel textId;
  private JLabel textQuestion;
  private JTextPane textAnswer;
  private JTextPane textDescription;
  private Question question=null;

  public HelpWindow(){
    super("HILFE");
    setSize(300,400);
    setIconImage(LoadIcon.loadImage("tester"));
    addWindowListener(new WindowAdapter(){ public void windowClosing(WindowEvent e){ actionClose(); }});
    setLayout(new BorderLayout());
    
    HelpLeiste hl=new HelpLeiste();
    hl.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e){ performAction(e.getActionCommand()); }});
    add(hl,BorderLayout.SOUTH);
    
    JPanel panelQuestion = new JPanel();
    panelQuestion.setLayout(new GridBagLayout());
    add(panelQuestion,BorderLayout.NORTH);

    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.FIRST_LINE_START;
    c.insets = new Insets(5,5,5,5);
    c.weightx=1.0;
    c.weighty=0.0;
    c.gridx=0;
    c.gridy=0;
    
    textId = new JLabel();
    panelQuestion.add(textId,c);

    c.gridy=1;
    textQuestion = new JLabel();
    panelQuestion.add(textQuestion,c);
    
    c.gridy=2;
    panelQuestion.add(new JSeparator(SwingConstants.HORIZONTAL),c);

    c.gridy=3;
    panelQuestion.add(new JLabel("Korrekte Antwort:"),c);

    c.gridy=4;
    textAnswer = new JTextPane();
    panelQuestion.add(textAnswer,c);
    
    c.gridy=5;
    panelQuestion.add(new JSeparator(SwingConstants.HORIZONTAL),c);

    c.gridy=6;
    panelQuestion.add(new JLabel("Erklhrung:"),c);


    textDescription = new JTextPane();
    add(textDescription,BorderLayout.CENTER);
  }
  
  public void setQuestion(Question q)
  {
    question = q;
    if(question != null)
    {
      textQuestion.setText(Tools.preformatQuestion("<font color=gray>Frage Nr.: "+q.getId()+"</font>\n"+q.getQuestionText()));
      textAnswer.setText(q.getTrueAnswersAsString());
      textDescription.setText(q.getDescriptionText());
    }
    else
    {
      textQuestion.setText("");
      textQuestion.setText("");
      textAnswer.setText("");
      textDescription.setText("");
    }
  }
  
  private void performAction(String cmd)
  { if(cmd.equals("HWCLOSE")) actionClose(); }
  
  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void doAction(String name)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(this, 0, name)); }

  private void actionClose()
  {
    this.setVisible(false);
    //this.dispose();
    doAction("HWCLOSE");
  }
}
