package gui;

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;

public abstract class Leiste extends JPanel{
  private static final long serialVersionUID = -9206744047639322439L;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();
  private ArrayList<JButton> list = new ArrayList<JButton>();
  Dimension dim=new Dimension(20,20);

  private class ActionL implements ActionListener{
    String cmd="";
    public ActionL(String s){cmd=s;}
    public void actionPerformed(ActionEvent e){doAction(cmd);}
  }
  
  protected JButton createButton(String icon,String cmd){ return createButton(null,icon,cmd,-1);}
  protected JButton createButton(String icon,String cmd, int key){ return createButton(null,icon,cmd,key);}
  protected JButton createButton(String text ,String icon,String cmd){return createButton(text,icon,cmd, -1); }
  protected JButton createButton(String text ,String icon,String cmd, int key)
  {
    JButton button;
    if(text != null && text.length()>0) button = new JButton(text, LoadIcon.scale(LoadIcon.load(icon),dim));
    else button = new JButton(LoadIcon.scale(LoadIcon.load(icon),dim));
    if(key >= 0) button.setMnemonic(key);
    button.addActionListener(new ActionL(cmd));
    button.setActionCommand(cmd);
    list.add(button);
    return button;
  }
  
  public void setButtonEnabled(String cmd, boolean b)
  {
    if(cmd != null)
    {
      for(JButton btn: list)
      { if(btn != null && btn.getActionCommand().equals(cmd)) btn.setEnabled(b); }
    }
  }

  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void doAction(String name)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(this, 0, name)); }
}
