package gui;

import java.awt.Dimension;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

public class LoadIcon extends ImageIcon{
  
  private static final long serialVersionUID = -1257340691914105336L;
  public static String base="imgs/gtk-";
  public static String ending=".png";
  

  LoadIcon(String name){super(getPath(completePath(name)));}
  
  private static String completePath(String name){ return base+name+ending; }
  
  public static URL getPath(String path)
  {
    URL url = LoadIcon.class.getResource("/"+path);
    if (url == null) try
      { url = new File(path).toURI().toURL(); } 
      catch (MalformedURLException e)
      { url=null; }
    return url;
  }
  
  public static ImageIcon load(String name)
  {
    URL imgURL = getPath(completePath(name));
    if (imgURL != null) return new ImageIcon(imgURL);
    return null;
  }
  
  public static ImageIcon scale(ImageIcon icon, Dimension dim)
  { return new ImageIcon(icon.getImage().getScaledInstance(dim.width,dim.height,Image.SCALE_SMOOTH)); }
  
  public static Image loadImage(String name)
  {
    URL imgURL = getPath(completePath(name));
    if (imgURL != null)
      try {
        return ImageIO.read(imgURL);
      } catch (IOException e) {
        return null;
      }
    return null;
  }
}
