package gui;

import java.awt.BorderLayout;
import java.awt.event.*;
import javax.swing.*;

import database.Question;

import java.util.*;

public class MainWindow extends JFrame{

  private static final long serialVersionUID = -108474455942561579L;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();
  
  private Menu menu = new Menu();
  private Leiste leisteoben = new LeisteOben();
  private ViewQuestion question = new ViewQuestion();
  private Leiste leisteunten = new LeisteUnten();

  
  public MainWindow()
  {
    super("FragenTester");
    setIconImage(LoadIcon.loadImage("tester"));
    addWindowListener(new WindowAdapter(){ public void windowClosing(WindowEvent e){ actionExit(); }});
    setLayout(new BorderLayout());
    
    ActionListener acl=new ActionListener(){public void actionPerformed(ActionEvent e){ actionCommand(e.getActionCommand(),e.getSource());}};
    menu.addActionListener(acl);
    leisteoben.addActionListener(acl);
    leisteunten.addActionListener(acl);

    setJMenuBar(menu);
    add(leisteoben,BorderLayout.NORTH);
    add(question,BorderLayout.CENTER);
    add(leisteunten,BorderLayout.SOUTH);
    endTest();
    
    pack();
    setVisible(true);
  }
  
  public void startTest()
  {
    leisteoben.setButtonEnabled("QFIRST", true);
    leisteoben.setButtonEnabled("QBEVORE", true);
    leisteoben.setButtonEnabled("TEND", true);
    leisteoben.setButtonEnabled("QNEXT", true);
    leisteoben.setButtonEnabled("QLAST", true);

    leisteunten.setButtonEnabled("TEND", true);
    leisteunten.setButtonEnabled("QNEXT", true);
    
    menu.setItemEnabled("DBSEL",false);
    menu.setItemEnabled("DBCONF",false);
    menu.setItemEnabled("TPROBE",false);
    menu.setItemEnabled("TSTART",false);
    menu.setItemEnabled("TCONF",false);
    menu.setItemEnabled("SSHOW",false);
    menu.setItemEnabled("SSAVE",false);
    menu.setItemEnabled("TEND",true);
  }
  
  public void probeTest()
  {
    menu.setItemEnabled("THELP",true);
    leisteunten.setButtonEnabled("THELP", true);
    leisteoben.setButtonEnabled("QTEST", true);
    leisteoben.setButtonEnabled("THELP", true);
    question.setDisabled(false);
  }
  
  
  public void endTest()
  {
    leisteoben.setButtonEnabled("QFIRST", false);
    leisteoben.setButtonEnabled("QBEVORE", false);
    leisteoben.setButtonEnabled("TEND", false);
    leisteoben.setButtonEnabled("QTEST", false);
    leisteoben.setButtonEnabled("THELP", false);
    leisteoben.setButtonEnabled("QNEXT", false);
    leisteoben.setButtonEnabled("QLAST", false);

    leisteunten.setButtonEnabled("TEND", false);
    leisteunten.setButtonEnabled("QNEXT", false);
    leisteunten.setButtonEnabled("THELP", false);
    
    menu.setItemEnabled("DBSEL",true);
    menu.setItemEnabled("DBCONF",true);
    menu.setItemEnabled("TPROBE",true);
    menu.setItemEnabled("TSTART",true);
    menu.setItemEnabled("TCONF",true);
    menu.setItemEnabled("SSHOW",true);
    menu.setItemEnabled("SSAVE",true);
    menu.setItemEnabled("THELP",false);
    menu.setItemEnabled("TEND",false);
    
    //question.setDisabled(true);
    question.setQuestion(null,false);
  }
  
  public void setQuestion( Question q, boolean e ){ question.setQuestion(q,e); }
  public Question getQuestion(){ return question.getQuestion(); }
  public void testCorrect(){ question.testCorrect(); }
  
  public void disableNext(boolean b)
  {
    b=!b;
    leisteoben.setButtonEnabled("QNEXT", b);
    leisteoben.setButtonEnabled("QLAST", b);
    leisteunten.setButtonEnabled("QNEXT", b);
  }
  
  public void disablePrevious(boolean b)
  {
    b=!b;
    leisteoben.setButtonEnabled("QFIRST", b);
    leisteoben.setButtonEnabled("QBEVORE", b);
  }
    
  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void doAction(String name,Object o)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(o, 0, name)); }
  private void actionExit()
  {
    this.setVisible(false);
    this.dispose();
    doAction("EXIT", this);
  }

  private void actionCommand(String cmd, Object o)
  {
    if(cmd.equals("EXIT")) actionExit();
    else doAction(cmd, o);
  }
}
