package gui;

import java.awt.event.*;
import java.util.ArrayList;

import javax.swing.*;

public class Menu extends JMenuBar{
  private static final long serialVersionUID = -5617155576631422259L;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();
  private ArrayList<JMenuItem> list = new ArrayList<JMenuItem>();
  
  private class ActionL implements ActionListener{
    String cmd="";
    Object o=null;
    public ActionL(String s,Object o){cmd=s; this.o=o;}
    public void actionPerformed(ActionEvent e){doAction(cmd,o);}
  }
  
  public Menu()
  {
    JMenu file = createMenu("Einstellungen",KeyEvent.VK_L);
    file.add(crateMenuItem("OEffnen",       "open",        "LOAD",     KeyEvent.VK_O, KeyEvent.VK_O));
    file.add(crateMenuItem("Speichern",     "save",        "SAVE",     KeyEvent.VK_S, KeyEvent.VK_S));
    file.addSeparator();
    file.add(crateMenuItem("Bearbeiten",    "preferences", "CONF",     KeyEvent.VK_B));
    file.addSeparator();
    file.add(crateMenuItem("Exit",          "quit",        "EXIT",     KeyEvent.VK_X, KeyEvent.VK_Q));

    JMenu db = createMenu("DataBase",       KeyEvent.VK_D);
    db.add(crateMenuItem("Auswhlen",       "network",     "DBSEL",    KeyEvent.VK_W, KeyEvent.VK_W));
    db.add(crateMenuItem("Konfiguration",   "properties",  "DBCONF",   KeyEvent.VK_K, KeyEvent.VK_K));
    
    JMenu test = createMenu("Test",         KeyEvent.VK_T);
    test.add(crateMenuItem("UEbung",        "new",          "TPROBE",   KeyEvent.VK_U, KeyEvent.VK_U));
    test.add(crateMenuItem("Test",          "index",        "TSTART",   KeyEvent.VK_T, KeyEvent.VK_T));
    test.add(crateMenuItem("Test Beenden",  "stop",         "TEND",   KeyEvent.VK_T, KeyEvent.VK_T));
    test.add(crateMenuItem("Konfiguration", "properties",   "TCONF",    KeyEvent.VK_G));
    test.add(crateMenuItem("Hilfe",         "help",         "THELP",    KeyEvent.VK_H));

    JMenu score = createMenu("Ergebnisse",  KeyEvent.VK_E);
    score.add(crateMenuItem("Anzeigen",     "spell-check",  "SSHOW",    KeyEvent.VK_A,KeyEvent.VK_A));
    score.add(crateMenuItem("Speichern",    "save",         "SSAVE",    KeyEvent.VK_R));
  }


  private JMenu createMenu(String text, int key)
  {
    JMenu menu = new JMenu(text);
    if(key>=0) menu.setMnemonic(key);
    add(menu);
    return menu;
  }

  private JMenuItem crateMenuItem(String name, String icon, String action, int key){ return crateMenuItem(name,icon,action,key,-1); }
  private JMenuItem crateMenuItem(String name, String icon, String action, int key, int key2)
  {
    JMenuItem item = new JMenuItem(name,LoadIcon.load(icon));
    if(key2 >=0) item.setAccelerator(KeyStroke.getKeyStroke(key2, ActionEvent.CTRL_MASK ));
    if(key >=0) item.setMnemonic(key);
    item.addActionListener(new ActionL(action,item));
    item.setActionCommand(action);
    list.add(item);
    return item;
  }

  public void setItemEnabled(String cmd, boolean b)
  {
    if(cmd != null)
    {
      for(JMenuItem btn: list)
      { if(btn != null && btn.getActionCommand().equals(cmd)) btn.setEnabled(b); }
    }
  }

  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void doAction(String name,Object o)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(o, 0, name)); }
}
