package gui;

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;

import database.DataBase;

public class SummaryWindow extends JFrame{
  private static final long serialVersionUID = -297522335924655595L;
  private ArrayList<ActionListener> action = new ArrayList<ActionListener>();
  
  private SummaryList list;
  
  SummaryWindow()
  {
    super("Zusammenfassung");
    setSize(300,400);
    setIconImage(LoadIcon.loadImage("tester"));
    addWindowListener(new WindowAdapter(){ public void windowClosing(WindowEvent e){ actionClose(); }});
    setLayout(new BorderLayout());
    
    list= new SummaryList();
    list.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e){ performAction(e.getActionCommand(), e.getSource()); }});

    JScrollPane scroll = new JScrollPane(list);
    scroll.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    scroll.setPreferredSize(new Dimension(250, 145));
    scroll.setMinimumSize(new Dimension(10, 10));
    add(scroll,BorderLayout.CENTER);
    
    SummaryLeiste hl=new SummaryLeiste();
    hl.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e){ performAction(e.getActionCommand(), e.getSource()); }});
    add(hl,BorderLayout.SOUTH);
    setVisible(false);
  }
  
  public void setDataBase(DataBase db)
  { list.setDataBase(db); }

  private void performAction(String cmd, Object o)
  {
    if(cmd.equals("SWCLOSE"))     actionClose();
    else if(cmd.equals("SWHELP")) action(cmd,o);
  }

  
  public void addActionListener(ActionListener l){action.add(l);}
  public void removeActionListener(ActionListener l){action.remove(l);}
  private void action(String name, Object o)
  { for(ActionListener l:action) l.actionPerformed(new ActionEvent(o, 0, name)); }

  private void actionClose()
  {
    this.setVisible(false);
    list.setDataBase(null);
    //this.dispose();
    action("SWCLOSE", this);
  }
  
}

