package gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

import database.Question;

//################################################################################
public class ViewQuestion extends JPanel{
  private static final long serialVersionUID = -262093076219755681L;

  private JLabel question;
  private ShowAnswers answers;
  private JLabel ltest;
  private JLabel lid;
  private JButton btest;

  private Question frage;

  ViewQuestion()
  {
    super();
    setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.gridwidth=1;
    c.gridheight=1;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.FIRST_LINE_START;
    c.insets = new Insets(10,10,10,10);
    c.weightx=1.0;
    c.weighty=0.0;
    c.gridx=0;

    c.gridy=0;
    lid=new JLabel("");
    add(lid,c);
    
    c.gridy=1;
    question = new ShowQuestion("");
    add(question,c);

    c.gridy=2;
    answers=new ShowAnswers();
    add(answers,c);
    
    c.gridy=3;
    c.weighty=1.0;
    c.fill = GridBagConstraints.BOTH;
    add(new Label(),c);
    
    c.gridy=4;
    c.weighty=0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    btest =new JButton("Antwort Pfen",LoadIcon.scale(LoadIcon.load("spell-check"),new Dimension(20,20)));
    btest.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e) { testCorrect(); }});
    add(btest,c);

    c.gridy=5;
    ltest =new JLabel("",JLabel.CENTER);
    add(ltest,c);

    cleanup();
  }
  
  private void cleanup()
  {
    setId("");
    setQuestion("");
    answers.show(null);
    btest.setEnabled(false);
    resetCorrect();
  }
  
  public void setQuestion(Question q,boolean enable)
  {
    frage=q;
    if(q != null)
    {
      setId(frage.getId());
      setQuestion(frage.getQuestionText());
      btest.setEnabled(enable);
      answers.show(frage.getAnswers());
      resetCorrect();
    }
    else
    { cleanup(); }
  }
  
  public Question getQuestion(){ return frage; }
  
  private void setId(String id)
  { lid.setText("Frage Nr.: "+id); }

  private void setQuestion(String q)
  { question.setText(q); }

  public void setTestButton()
  { btest.setEnabled(true); }

  private void resetCorrect()
  { ltest.setText("<html><font color=green size=+4>&nbsp;</font></html>"); }
  
  public void testCorrect()
  {
    if(frage.isAnswered())
    {
      if(frage.testUserAnswers())
      { ltest.setText("<html><font color=green size=+4>KORREKT</font></html>"); }
      else
      { ltest.setText("<html><font color=red size=+4>FALSCH</font></html>"); }
    }
    else
    { resetCorrect(); }
  }
  
  public void setDisabled(boolean b)
  {
    btest.setEnabled(!b);
    if(b)
    {
      setQuestion("");
      answers.show(null);
      resetCorrect();
      setId("");
    }
  }
}
//################################################################################

//################################################################################
//################################################################################

//################################################################################
