package main;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import gui.GUI;
import database.DataBase;

public class FragenTester implements ActionListener{
  
  private DataBase db;
  private GUI gui = new GUI();
  private Configuration conf=new Configuration();

  public static void main(String[] args)
  {
    new FragenTester();
  }
  
  private FragenTester()
  {
    File file=new File("FragenJava.db");
    loadDB(file);
    gui.addActionListener(this);
    conf.addActionListener(this);
    conf.load();
  }
  
  private void exit(){ System.exit(0); }

  public void actionPerformed(ActionEvent e)
  {
    String txt=e.getActionCommand();
    Object o=e.getSource();
    if(txt.equals("EXIT")) exit();
    else if(txt.equals("TEND"))
    { gui.endTest(); }
    else if(txt.equals("TPROBE"))
    {
      db.start();
      gui.setQuestion(db.getQuestion());
      gui.startProbeTest();
      gui.showQuestion();
      gui.disablePrevious(true);
      gui.hideSummary();
    }
    else if(txt.equals("TSTART"))
    {
      db.start();
      gui.setQuestion(db.getQuestion());
      gui.startRealTest();
      gui.showQuestion();
      gui.disablePrevious(true);
      gui.hideSummary();
    }
    else if(txt.equals("QTEST"))
    {
      gui.testCorrect();
    }
    else if(txt.equals("QNEXT"))
    {
      db.next();
      updateQuestion();
    }
    else if(txt.equals("QBEVORE"))
    {
      db.previous();
      updateQuestion();
    }
    else if(txt.equals("QLAST"))
    {
      db.last();
      updateQuestion();
    }
    else if(txt.equals("QFIRST"))
    {
      db.first();
      updateQuestion();
    }
    else if(txt.equals("DBQLAST"))
    {
      gui.disableNext(true);
      gui.disablePrevious(false);
    }
    else if(txt.equals("DBQFIRST"))
    {
      gui.disablePrevious(true);
      gui.disableNext(false);
    }
    else if(txt.equals("DBQMIDDLE"))
    {
      gui.disablePrevious(false);
      gui.disableNext(false);
    }
    else if(txt.equals("SSHOW"))
    {
      gui.setSummaryDataBase(db);
      gui.showSummary();
    }
    else if(txt.equals("DBCONF"))
    { gui.DBConf(db); }
    else if(txt.equals("DBSEL"))
    {
      loadDB(gui.openFile());
    }
    else if(txt.equals("SSAVE"))
    {
      saveScore(gui.saveAsFile());
    }
    else if(txt.equals("SAVE"))
    {
      saveConf(gui.saveAsFile());
    }
    else if(txt.equals("LOAD"))
    {
      loadConf(gui.openFile());
    }
    else if(txt.equals("CONF"))
    {
      gui.showConf(conf);
    }
    else if(txt.equals("CONFCHANGED"))
    {
      //gui.alert("CHANGE","Konfiguartion hat sich gendert","dialog-info");
    }
    else if(txt.equals("CONFLOADERROR"))
    {
      IOException ee=(IOException)o;
      gui.alert("ERROR LOAD CONF","<html>Fehler beim Laden der Konfiguration<br>&nbsp;<br><pre>"+ee.getLocalizedMessage()+"</pre><br>Es steht nur die Defaultkonfiguration zur Verfgung</html>","dialog-error");
    }

    else
    { gui.alert("MESSAGE",txt+" ("+o+")","dialog-info"); }
  }
  
  private void updateQuestion()
  {
    gui.setQuestion(db.getQuestion());
    gui.showQuestion();
  }
  
  private void saveScore(File file)
  {
    
  }
  
  private void loadConf(File file)
  {
    
  }
  
  private void saveConf(File file)
  {
    
  }
  
  private void loadDB(File file)
  {
    //System.out.println(file.getName());
    DataBase dbneu=null;
    if(file != null) try{
      if(file.getName().matches(".+\\.xdb$"))
        dbneu=DataBase.loadXDB(file);
      else if((file.getName().matches(".+\\.db$")))
        dbneu=DataBase.loadDB(file);
      else
        throw new IOException("keine korrekte Datei"); 
    }
    catch(IOException e)
    {
      gui.alert("ERROR LOAD FILE","<html>"+file+"<br>&nbsp;<br><pre>"+e.getLocalizedMessage()+"</pre></html>","dialog-error");
      exit();
    }
    if(dbneu != null)
    {
      if(db!=null)db.removeActionListener(this);
      db=dbneu;
      db.addActionListener(this);
      db.setMax(db.size()-1);
      db.sortQuestions();
      db.sortAnswers();
    }
  }

}
